Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/JobStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/JobStats.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/JobStats.java	(revision 1396)
@@ -1,7 +1,5 @@
 package simulator.stats.implementation;
 
-import java.io.PrintStream;
-
-import simulator.stats.GSSAccumulator;
+import simulator.stats.DCwormsAccumulator;
 import simulator.stats.implementation.out.StatsSerializer;
 
@@ -14,13 +12,13 @@
 
 	protected String jobID;
-	protected GSSAccumulator meanTaskCompletionTime;
-	protected GSSAccumulator meanTaskExecutionTime;
-	protected GSSAccumulator meanTaskStartTime;
-	protected GSSAccumulator meanTaskFlowTime;
-	protected GSSAccumulator meanTaskWaitingTime;
-	protected GSSAccumulator meanTaskGQ_WaitingTime;
-	protected GSSAccumulator lateness;
-	protected GSSAccumulator tardiness;
-	protected GSSAccumulator makespan;
+	protected DCwormsAccumulator meanTaskCompletionTime;
+	protected DCwormsAccumulator meanTaskExecutionTime;
+	protected DCwormsAccumulator meanTaskStartTime;
+	protected DCwormsAccumulator meanTaskFlowTime;
+	protected DCwormsAccumulator meanTaskWaitingTime;
+	protected DCwormsAccumulator meanTaskGQ_WaitingTime;
+	protected DCwormsAccumulator lateness;
+	protected DCwormsAccumulator tardiness;
+	protected DCwormsAccumulator makespan;
 
 	JobStats(String jobID) {
@@ -35,13 +33,13 @@
 
 	private void init() {
-		this.meanTaskCompletionTime = new GSSAccumulator();
-		this.meanTaskExecutionTime = new GSSAccumulator();
-		this.meanTaskStartTime = new GSSAccumulator();
-		this.meanTaskFlowTime = new GSSAccumulator();
-		this.meanTaskWaitingTime = new GSSAccumulator();
-		this.meanTaskGQ_WaitingTime = new GSSAccumulator();
-		this.lateness = new GSSAccumulator();
-		this.tardiness = new GSSAccumulator();
-		this.makespan = new GSSAccumulator();
+		this.meanTaskCompletionTime = new DCwormsAccumulator();
+		this.meanTaskExecutionTime = new DCwormsAccumulator();
+		this.meanTaskStartTime = new DCwormsAccumulator();
+		this.meanTaskFlowTime = new DCwormsAccumulator();
+		this.meanTaskWaitingTime = new DCwormsAccumulator();
+		this.meanTaskGQ_WaitingTime = new DCwormsAccumulator();
+		this.lateness = new DCwormsAccumulator();
+		this.tardiness = new DCwormsAccumulator();
+		this.makespan = new DCwormsAccumulator();
 	}
 
@@ -50,37 +48,37 @@
 	}
 
-	public GSSAccumulator getMeanTaskCompletionTime() {
+	public DCwormsAccumulator getMeanTaskCompletionTime() {
 		return meanTaskCompletionTime;
 	}
 
-	public GSSAccumulator getMeanTaskExecutionTime() {
+	public DCwormsAccumulator getMeanTaskExecutionTime() {
 		return meanTaskExecutionTime;
 	}
 
-	public GSSAccumulator getMeanTaskStartTime() {
+	public DCwormsAccumulator getMeanTaskStartTime() {
 		return meanTaskStartTime;
 	}
 
-	public GSSAccumulator getMeanTaskFlowTime() {
+	public DCwormsAccumulator getMeanTaskFlowTime() {
 		return meanTaskFlowTime;
 	}
 
-	public GSSAccumulator getMeanTaskWaitingTime() {
+	public DCwormsAccumulator getMeanTaskWaitingTime() {
 		return meanTaskWaitingTime;
 	}
 
-	public GSSAccumulator getMeanTaskGQ_WaitingTime() {
+	public DCwormsAccumulator getMeanTaskGQ_WaitingTime() {
 		return meanTaskGQ_WaitingTime;
 	}
 
-	public GSSAccumulator getLateness() {
+	public DCwormsAccumulator getLateness() {
 		return lateness;
 	}
 
-	public GSSAccumulator getTardiness() {
+	public DCwormsAccumulator getTardiness() {
 		return tardiness;
 	}
 
-	public GSSAccumulator getMakespan() {
+	public DCwormsAccumulator getMakespan() {
 		return makespan;
 	}
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/GSSAccumulatorsStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/GSSAccumulatorsStats.java	(revision 1277)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/GSSAccumulatorsStats.java	(revision 1396)
@@ -1,26 +1,26 @@
 package simulator.stats.implementation;
 
-import simulator.stats.GSSAccumulator;
+import simulator.stats.DCwormsAccumulator;
 import simulator.stats.implementation.out.StatsSerializer;
 
 public class GSSAccumulatorsStats implements StatsInterface {
 
-	public GSSAccumulator meanTotalOccupancy;
-	public GSSAccumulator meanTotalLoad;
-	public GSSAccumulator meanQueueLength;
-	public GSSAccumulator meanEnergyUsage;
-	public GSSAccumulator meanAirFlow;
-	public GSSAccumulator meanTemperature;
+	public DCwormsAccumulator meanTotalOccupancy;
+	public DCwormsAccumulator meanTotalLoad;
+	public DCwormsAccumulator meanQueueLength;
+	public DCwormsAccumulator meanEnergyUsage;
+	public DCwormsAccumulator meanAirFlow;
+	public DCwormsAccumulator meanTemperature;
 
-	public GSSAccumulator meanTaskStartTime;
-	public GSSAccumulator meanTaskCompletionTime;
-	public GSSAccumulator meanTaskExecutionTime;
-	public GSSAccumulator meanTaskWaitingTime;
-	public GSSAccumulator meanTaskFlowTime;
-	public GSSAccumulator lateness;
-	public GSSAccumulator tardiness;
-	public GSSAccumulator delayedTasks;
-	public GSSAccumulator failedRequests;
-	public GSSAccumulator makespan;
+	public DCwormsAccumulator meanTaskStartTime;
+	public DCwormsAccumulator meanTaskCompletionTime;
+	public DCwormsAccumulator meanTaskExecutionTime;
+	public DCwormsAccumulator meanTaskWaitingTime;
+	public DCwormsAccumulator meanTaskFlowTime;
+	public DCwormsAccumulator lateness;
+	public DCwormsAccumulator tardiness;
+	public DCwormsAccumulator delayedTasks;
+	public DCwormsAccumulator failedRequests;
+	public DCwormsAccumulator makespan;
 
 	private String[] headers = { "Resource name", "mean", "stdev", "variance",
@@ -28,21 +28,21 @@
 
 	public GSSAccumulatorsStats() {
-		meanTotalOccupancy = new GSSAccumulator();
-		meanTotalLoad = new GSSAccumulator();
-		meanQueueLength = new GSSAccumulator();
-		meanEnergyUsage = new GSSAccumulator(); 
-		meanAirFlow = new GSSAccumulator(); 
-		meanTemperature = new GSSAccumulator(); 
+		meanTotalOccupancy = new DCwormsAccumulator();
+		meanTotalLoad = new DCwormsAccumulator();
+		meanQueueLength = new DCwormsAccumulator();
+		meanEnergyUsage = new DCwormsAccumulator(); 
+		meanAirFlow = new DCwormsAccumulator(); 
+		meanTemperature = new DCwormsAccumulator(); 
 		
-		meanTaskStartTime = new GSSAccumulator();
-		meanTaskCompletionTime = new GSSAccumulator();
-		meanTaskExecutionTime = new GSSAccumulator();
-		meanTaskWaitingTime = new GSSAccumulator();
-		meanTaskFlowTime = new GSSAccumulator();
-		lateness = new GSSAccumulator();
-		tardiness = new GSSAccumulator();
-		delayedTasks = new GSSAccumulator();
-		failedRequests = new GSSAccumulator();
-		makespan = new GSSAccumulator();
+		meanTaskStartTime = new DCwormsAccumulator();
+		meanTaskCompletionTime = new DCwormsAccumulator();
+		meanTaskExecutionTime = new DCwormsAccumulator();
+		meanTaskWaitingTime = new DCwormsAccumulator();
+		meanTaskFlowTime = new DCwormsAccumulator();
+		lateness = new DCwormsAccumulator();
+		tardiness = new DCwormsAccumulator();
+		delayedTasks = new DCwormsAccumulator();
+		failedRequests = new DCwormsAccumulator();
+		makespan = new DCwormsAccumulator();
 	}
 
Index: DCWoRMS/branches/coolemall/src/simulator/stats/StatisticsInfo.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/StatisticsInfo.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/StatisticsInfo.java	(revision 1396)
@@ -9,11 +9,11 @@
 
 	/** The mean value */
-	protected GSSAccumulator mean;
+	protected DCwormsAccumulator mean;
 	/** The standard deviation value */
-	protected GSSAccumulator stdev;
+	protected DCwormsAccumulator stdev;
 	/** The minimal value */
-	protected GSSAccumulator max;
+	protected DCwormsAccumulator max;
 	/** The maximal value */
-	protected GSSAccumulator min;
+	protected DCwormsAccumulator min;
 	/**
 	 * @param mean
@@ -22,5 +22,5 @@
 	 * @param min
 	 */
-	public StatisticsInfo(GSSAccumulator mean, GSSAccumulator stdev, GSSAccumulator max, GSSAccumulator min) {
+	public StatisticsInfo(DCwormsAccumulator mean, DCwormsAccumulator stdev, DCwormsAccumulator max, DCwormsAccumulator min) {
 		this.mean = mean;
 		this.stdev = stdev;
@@ -31,5 +31,5 @@
 	 * @return the maximal value
 	 */
-	public GSSAccumulator getMax() {
+	public DCwormsAccumulator getMax() {
 		return max;
 	}
@@ -37,5 +37,5 @@
 	 * @return the mean value
 	 */
-	public GSSAccumulator getMean() {
+	public DCwormsAccumulator getMean() {
 		return mean;
 	}
@@ -43,5 +43,5 @@
 	 * @return the minimal value
 	 */
-	public GSSAccumulator getMin() {
+	public DCwormsAccumulator getMin() {
 		return min;
 	}
@@ -49,5 +49,5 @@
 	 * @return the standard deviation value
 	 */
-	public GSSAccumulator getStdev() {
+	public DCwormsAccumulator getStdev() {
 		return stdev;
 	}
Index: DCWoRMS/branches/coolemall/src/simulator/stats/CoolEmAllMetricsCalculator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/CoolEmAllMetricsCalculator.java	(revision 1331)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/CoolEmAllMetricsCalculator.java	(revision 1396)
@@ -51,5 +51,5 @@
 			
 			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
+			for(DCwormsAccumulator acc: metricsData.get("Room")){
 				roomPower = roomPower + acc.getSum();
 			}
@@ -66,5 +66,5 @@
 		try{
 			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
+			for(DCwormsAccumulator acc: metricsData.get("Processor")){
 				itComputingPower = itComputingPower + acc.getSum();
 			}
@@ -81,13 +81,13 @@
 		try{
 			double totalSitePower = 0; 
-			for(GSSAccumulator acc: metricsData.get("Rack")){
+			for(DCwormsAccumulator acc: metricsData.get("Rack")){
 				totalSitePower = totalSitePower + acc.getSum();
 			}
 			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
+			for(DCwormsAccumulator acc: metricsData.get("Node")){
 				nodeComputingPower = nodeComputingPower+ acc.getSum();
 			}
 			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
+			for(DCwormsAccumulator acc: metricsData.get("Processor")){
 				itComputingPower = itComputingPower + acc.getSum();
 			}
@@ -105,9 +105,9 @@
 		try{
 			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
+			for(DCwormsAccumulator acc: metricsData.get("Node")){
 				nodeComputingPower = nodeComputingPower+ acc.getSum();
 			}
 			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
+			for(DCwormsAccumulator acc: metricsData.get("Processor")){
 				itComputingPower = itComputingPower + acc.getSum();
 			}
@@ -126,10 +126,10 @@
 			
 			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
+			for(DCwormsAccumulator acc: metricsData.get("Room")){
 				roomPower = roomPower + acc.getSum();
 			}
 			
 			double totalSitePower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
+			for(DCwormsAccumulator acc: metricsData.get("Rack")){
 				totalSitePower = totalSitePower + acc.getSum();
 			}
@@ -137,9 +137,9 @@
 		
 			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
+			for(DCwormsAccumulator acc: metricsData.get("Node")){
 				nodeComputingPower = nodeComputingPower+ acc.getSum();
 			}
 			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
+			for(DCwormsAccumulator acc: metricsData.get("Processor")){
 				itComputingPower = itComputingPower + acc.getSum();
 			}
@@ -159,10 +159,10 @@
 			
 			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
+			for(DCwormsAccumulator acc: metricsData.get("Room")){
 				roomPower = roomPower + acc.getSum();
 			}
 			
 			double totalSitePower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
+			for(DCwormsAccumulator acc: metricsData.get("Rack")){
 				totalSitePower = totalSitePower + acc.getSum();
 			}
@@ -183,5 +183,5 @@
 			for(String key: metricsData.keySet()){
 				if(key.contains("UW_")){
-					for(GSSAccumulator acc: metricsData.get(key)){
+					for(DCwormsAccumulator acc: metricsData.get(key)){
 						usefulWork= usefulWork + acc.getSum();
 					}
@@ -203,5 +203,5 @@
 			for(String key: metricsData.keySet()){
 				if(key.contains("/")){
-					for(GSSAccumulator acc: metricsData.get(key)){
+					for(DCwormsAccumulator acc: metricsData.get(key)){
 						usefulWork= usefulWork + acc.getSum();
 					}
@@ -209,5 +209,5 @@
 			}
 			double totalSitePower = 0; 
-			for(GSSAccumulator acc: metricsData.get("Rack")){
+			for(DCwormsAccumulator acc: metricsData.get("Rack")){
 				totalSitePower = totalSitePower + acc.getSum();
 			}
@@ -228,5 +228,5 @@
 			double maxPower = 0;
 			
-			for(GSSAccumulator acc: metricsData.get("Rack_MAX")){
+			for(DCwormsAccumulator acc: metricsData.get("Rack_MAX")){
 				maxPower = maxPower + acc.getSum();
 			}
@@ -246,5 +246,5 @@
 			double maxPower = 0;
 			
-			for(GSSAccumulator acc: metricsData.get("Room_MAX")){
+			for(DCwormsAccumulator acc: metricsData.get("Room_MAX")){
 				maxPower = maxPower + acc.getSum();
 			}
@@ -263,19 +263,19 @@
 		try{
 			double inletsPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Inlet")){
+			for(DCwormsAccumulator acc: metricsData.get("Inlet")){
 				inletsPower = inletsPower + acc.getSum();
 			}
 			
 			double outletsPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Outlet")){
+			for(DCwormsAccumulator acc: metricsData.get("Outlet")){
 				outletsPower = outletsPower + acc.getSum();
 			}
 			
 			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
+			for(DCwormsAccumulator acc: metricsData.get("Node")){
 				nodeComputingPower = nodeComputingPower+ acc.getSum();
 			}
 			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
+			for(DCwormsAccumulator acc: metricsData.get("Processor")){
 				itComputingPower = itComputingPower + acc.getSum();
 			}
@@ -294,5 +294,5 @@
 		try{
 			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
+			for(DCwormsAccumulator acc: metricsData.get("Rack")){
 				roomPower = roomPower + acc.getSum();
 			}
@@ -309,5 +309,5 @@
 		try{
 			double coolingDevicePower = 0;
-			for(GSSAccumulator acc: metricsData.get("CoolingDevice")){
+			for(DCwormsAccumulator acc: metricsData.get("CoolingDevice")){
 				coolingDevicePower = coolingDevicePower + acc.getSum();
 			}
@@ -327,5 +327,5 @@
 			for(String key: metricsData.keySet()){
 				if(key.contains("FlowPump")){
-					for(GSSAccumulator acc: metricsData.get(key)){
+					for(DCwormsAccumulator acc: metricsData.get(key)){
 						flowPump = flowPump + acc.getSum();
 					}
@@ -346,34 +346,34 @@
 		try{
 			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
+			for(DCwormsAccumulator acc: metricsData.get("Room")){
 				roomPower = roomPower + acc.getSum();
 			}
 			
 			double totalSitePower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
+			for(DCwormsAccumulator acc: metricsData.get("Rack")){
 				totalSitePower = totalSitePower + acc.getSum();
 			}
 			
 			double coolingDevicePower = 0;
-			for(GSSAccumulator acc: metricsData.get("CoolingDevice")){
+			for(DCwormsAccumulator acc: metricsData.get("CoolingDevice")){
 				coolingDevicePower = coolingDevicePower + acc.getSum();
 			}
 			
 			double inletsPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Inlet")){
+			for(DCwormsAccumulator acc: metricsData.get("Inlet")){
 				inletsPower = inletsPower + acc.getSum();
 			}
 			
 			double outletsPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Outlet")){
+			for(DCwormsAccumulator acc: metricsData.get("Outlet")){
 				outletsPower = outletsPower + acc.getSum();
 			}
 			
 			double nodeComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Node")){
+			for(DCwormsAccumulator acc: metricsData.get("Node")){
 				nodeComputingPower = nodeComputingPower+ acc.getSum();
 			}
 			double itComputingPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Processor")){
+			for(DCwormsAccumulator acc: metricsData.get("Processor")){
 				itComputingPower = itComputingPower + acc.getSum();
 			}
@@ -394,5 +394,5 @@
 			
 			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Room")){
+			for(DCwormsAccumulator acc: metricsData.get("Room")){
 				roomPower = roomPower + acc.getSum();
 			}
@@ -411,5 +411,5 @@
 			
 			double roomPower = 0;
-			for(GSSAccumulator acc: metricsData.get("Rack")){
+			for(DCwormsAccumulator acc: metricsData.get("Rack")){
 				roomPower = roomPower + acc.getSum();
 			}
@@ -427,5 +427,5 @@
 			double itComputingEnergy = 0;
 			
-			for(GSSAccumulator acc: metricsData.get("Processor_CALC")){
+			for(DCwormsAccumulator acc: metricsData.get("Processor_CALC")){
 				itComputingEnergy = itComputingEnergy + acc.getSum();
 			}
Index: DCWoRMS/branches/coolemall/src/simulator/reader/ResourceReader.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/reader/ResourceReader.java	(revision 1374)
+++ DCWoRMS/branches/coolemall/src/simulator/reader/ResourceReader.java	(revision 1396)
@@ -26,5 +26,4 @@
 import schedframe.Parameters;
 import schedframe.SimulatedEnvironment;
-import schedframe.exceptions.ResourceException;
 import schedframe.resources.CoolEmAllResourceFactory;
 import schedframe.resources.Resource;
Index: DCWoRMS/branches/coolemall/src/simulator/ConfigurationOptions.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/ConfigurationOptions.java	(revision 1299)
+++ DCWoRMS/branches/coolemall/src/simulator/ConfigurationOptions.java	(revision 1396)
@@ -187,5 +187,5 @@
 	
 	public String [] resForEnergyChart;
-	public String [] resForAirFlowChart;
+	public String [] resForAirflowChart;
 	public String [] resForTemperatureChart;
 	public String [] resForUtilizationChart;
@@ -195,5 +195,5 @@
 	public double inletRoomAirTempeature;
 	public double ambientAirTempeature;
-	public double airFlowVolume;
+	public double airflowVolume;
 	public double alpha;
 	
@@ -334,6 +334,6 @@
 		
 		try {
-			co.resForAirFlowChart = bundle.getString(CREATEDIAGRAMS_AIRFLOW).split(";");
-			if(co.resForAirFlowChart.length > 0){
+			co.resForAirflowChart = bundle.getString(CREATEDIAGRAMS_AIRFLOW).split(";");
+			if(co.resForAirflowChart.length > 0){
 				co.creatediagrams_resairflow = true;
 			}
@@ -416,7 +416,7 @@
 		
 		try {
-			co.airFlowVolume = Double.valueOf(bundle.getString(AIR_FLOW_VOLUME)).doubleValue();
-		} catch(MissingResourceException e){
-			co.airFlowVolume = -1;
+			co.airflowVolume = Double.valueOf(bundle.getString(AIR_FLOW_VOLUME)).doubleValue();
+		} catch(MissingResourceException e){
+			co.airflowVolume = -1;
 		}
 		
@@ -427,5 +427,5 @@
 		}
 		
-		ConfigurationOptions.coolingData = new CoolingModelData(co.pressureDrop, co.outletRoomAirTempeature, co.inletRoomAirTempeature, co.ambientAirTempeature, co.airFlowVolume, co.alpha);
+		ConfigurationOptions.coolingData = new CoolingModelData(co.pressureDrop, co.outletRoomAirTempeature, co.inletRoomAirTempeature, co.ambientAirTempeature, co.airflowVolume, co.alpha);
 		return co;
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/Job.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/Job.java	(revision 1374)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/Job.java	(revision 1396)
@@ -1,9 +1,3 @@
 package schedframe.scheduling.tasks;
-
-
-import org.qcg.broker.schemas.resreqs.ParentType;
-import org.qcg.broker.schemas.resreqs.ResourceRequirements;
-import org.qcg.broker.schemas.resreqs.Workflow;
-import org.qcg.broker.schemas.resreqs.types.TaskStatesName;
 
 
@@ -15,7 +9,7 @@
 
 import org.joda.time.DateTime;
+import org.qcg.broker.schemas.resreqs.ResourceRequirements;
 
 import qcg.shared.constants.BrokerConstants;
-
 import schedframe.scheduling.WorkloadUnitHandler;
 import schedframe.scheduling.manager.tasks.JobRegistryImpl;
@@ -210,83 +204,3 @@
 	}
 	
-	private List<Task> getReadyTasks() throws NoSuchFieldException{
-		
-		List<Task> availableTasks = new ArrayList<Task>();
-		int size = tasks.size();
-		
-		for(int i = 0; i < size; i++){
-			int parCnt;
-			int previousTaskSucceedCnt = 0;
-			Task task = tasks.get(i);
-			if(task.getStatus() != (int)BrokerConstants.TASK_STATUS_UNSUBMITTED)
-				continue;
-			//the following procedure supports only one nested structure
-			Workflow w = task.getDescription().getWorkflow();
-			if (w == null){
-				availableTasks.add(task);
-				continue;
-			}
-			if(w.getAnd() != null) {
-				parCnt = w.getAnd().getParentOpTypeItemCount();
-				if(parCnt == 0){
-					availableTasks.add(task);
-				}else
-				{
-					for(int j = 0; j < parCnt; j++){
-						ParentType par = w.getAnd().getParentOpTypeItem(j).getParent();
-						if(par.getTriggerState().compareTo(TaskStatesName.FINISHED) == 0){
-							if(!getTask(par.getContent()).isFinished()){
-								break;
-							}
-						}
-						previousTaskSucceedCnt++;
-					}
-
-					if(previousTaskSucceedCnt == parCnt)
-						availableTasks.add(task);
-				}
-			} 
-			else if(w.getOr() != null) {
-				parCnt = w.getOr().getParentOpTypeItemCount();
-				if(parCnt == 0){
-					availableTasks.add(task);
-				}
-				else{
-					for(int j = 0; j < parCnt; j++){
-						ParentType par = w.getOr().getParentOpTypeItem(j).getParent();
-						if(par.getTriggerState().compareTo(TaskStatesName.FINISHED) == 0){
-							if(!getTask(par.getContent()).isFinished()){
-								continue;
-							}
-						}
-						previousTaskSucceedCnt++;
-					}
-
-					if(previousTaskSucceedCnt > 0)
-						availableTasks.add(task);
-				}
-			}
-			else {
-				parCnt = w.getParentCount();
-				if(parCnt == 0){
-					availableTasks.add(task);
-				}else{
-					for(int j = 0; j < parCnt; j++){
-						ParentType par = w.getParent(j);
-						if(par.getTriggerState().compareTo(TaskStatesName.FINISHED) == 0){
-							if(!getTask(par.getContent()).isFinished()){
-								continue;
-							}
-						}
-						previousTaskSucceedCnt++;
-					}
-
-					if(previousTaskSucceedCnt == parCnt)
-						availableTasks.add(task);
-				}
-			}
-		}		
-		return availableTasks;
-	}
-	
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/ResourceItem.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/ResourceItem.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/ResourceItem.java	(revision 1396)
@@ -0,0 +1,57 @@
+package schedframe.scheduling;
+
+import java.util.HashSet;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.ResourceUnit;
+import schedframe.resources.units.ResourceUnitName;
+import schedframe.resources.units.StandardResourceUnitName;
+
+public class ResourceItem {
+
+	protected Map<ResourceUnitName, ResourceUnit> usedResources;
+	protected Set<String> visitedResources;
+
+	public ResourceItem(Map<ResourceUnitName, ResourceUnit> usedResources){
+		this.usedResources = usedResources;
+		this.visitedResources = new HashSet<String>();
+		saveResourceNames();
+	}
+	
+	public Map<ResourceUnitName, ResourceUnit> getResourceUnits(){
+		return usedResources;
+	}
+	
+	public Set<String> getResourceNames(){
+		return visitedResources;
+	}
+	
+	private void saveResourceNames(){
+		ProcessingElements pes = (ProcessingElements) usedResources.get(StandardResourceUnitName.PE);
+		for (ComputingResource resource : pes) {
+
+			LinkedList<ComputingResource> toExamine = new LinkedList<ComputingResource>();
+			toExamine.push(resource);
+
+			while (!toExamine.isEmpty()) {
+				ComputingResource compResource = toExamine.pop();
+				List<ComputingResource> resources = compResource.getChildren();
+				if(resources.isEmpty()){
+					if(!visitedResources.contains(compResource.getFullName())){
+						visitedResources.add(compResource.getFullName());
+					}
+				} else {
+					for (int i = 0; i < resources.size(); i++) {
+						ComputingResource resourceChild = resources.get(i);
+						toExamine.addLast(resourceChild);
+					}
+				}
+			}
+		}
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/ModuleType.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/ModuleType.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/ModuleType.java	(revision 1396)
@@ -0,0 +1,36 @@
+package schedframe.scheduling.plugin;
+
+
+import schedframe.scheduling.plugin.grid.ResourceDiscovery;
+import test.EventManager;
+
+
+/**
+ * 
+ * @author Marcin Krystek
+ *
+ */
+public enum ModuleType {
+
+	RESOURCE_DISCOVERY("Resource_discovery", ResourceDiscovery.class),
+	EVENT_MANAGER("Event manager", EventManager.class);
+	//DATA_MANAGER("Data Manager", DataManager.class),
+	//AR_EXTENSION("ARExtension", ARExtension.class);
+
+	
+	private String name;
+	private Class<?> _interface;
+	
+	private ModuleType(String name, Class<?> _class){
+		this.name = name;
+		this._interface = _class;
+	}
+	
+	public String toString(){
+		return this.name;
+	}
+	
+	public boolean isValidFor(Module m){
+		return (m == null ? false : _interface.isAssignableFrom(m.getClass()));
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/local/LocalSchedulingPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/local/LocalSchedulingPlugin.java	(revision 515)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/local/LocalSchedulingPlugin.java	(revision 1396)
@@ -5,6 +5,6 @@
 import schedframe.scheduling.manager.resources.ResourceManager;
 import schedframe.scheduling.manager.tasks.JobRegistry;
+import schedframe.scheduling.plugin.ModuleList;
 import schedframe.scheduling.plugin.SchedulingPlugin;
-import schedframe.scheduling.plugin.grid.ModuleList;
 import schedframe.scheduling.queue.TaskQueueList;
 
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/ModuleList.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/ModuleList.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/ModuleList.java	(revision 1396)
@@ -0,0 +1,12 @@
+package schedframe.scheduling.plugin;
+
+import java.util.List;
+
+public interface ModuleList extends List<Module>{
+	
+	public <T extends Module> List<T> get(ModuleType type);
+	
+	public Module getModule(ModuleType type);
+	
+	public boolean isModuleAvailable(ModuleType type);
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/ModuleListImpl.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/ModuleListImpl.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/ModuleListImpl.java	(revision 1396)
@@ -0,0 +1,58 @@
+package schedframe.scheduling.plugin;
+
+import java.util.ArrayList;
+import java.util.List;
+
+/**
+ * 
+ * @author Marcin Krystek
+ *
+ */
+public class ModuleListImpl extends ArrayList<Module> implements ModuleList {
+
+	private static final long serialVersionUID = -3824600938144742457L;
+
+	public ModuleListImpl(){
+		super();
+	}
+	
+	public ModuleListImpl(int initialSize){
+		super(initialSize);
+	}
+	
+	public List<Module> get(ModuleType type){
+		List<Module> list = null;
+		
+		for(int i = 0; i < size(); i++){
+			Module m = get(i);
+			if(m.getType() == type){
+				list = (list == null ? new ArrayList<Module>(1) : list);
+				list.add(m);
+			}
+		}
+		return list;
+	}
+	
+	public Module getModule(ModuleType type){
+		
+		for(int i = 0; i < size(); i++){
+			Module m = get(i);
+			if(m.getType() == type){
+				return m;
+			}
+		}
+		return null;
+	}
+	
+	public boolean isModuleAvailable(ModuleType type){
+		for(int i = 0; i < size(); i++){
+			Module m = get(i);
+			if(m.getType() == type){
+				return true;
+			}
+		}
+		return false;
+	}
+	
+	
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/SchedulingPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/SchedulingPlugin.java	(revision 516)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/SchedulingPlugin.java	(revision 1396)
@@ -7,5 +7,4 @@
 import schedframe.scheduling.manager.tasks.JobRegistry;
 import schedframe.scheduling.plan.SchedulingPlanInterface;
-import schedframe.scheduling.plugin.grid.ModuleList;
 import schedframe.scheduling.queue.TaskQueueList;
 
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/Module.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/Module.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/Module.java	(revision 1396)
@@ -0,0 +1,20 @@
+package schedframe.scheduling.plugin;
+
+import java.util.Properties;
+
+import schedframe.exceptions.ModuleException;
+
+/**
+ * 
+ * @author Marcin Krystek
+ *
+ */
+public interface Module {
+
+	public void init(Properties properties) throws ModuleException;
+	
+	public void dispose() throws ModuleException;
+	
+	public ModuleType getType();
+	
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/grid/ResourceDiscovery.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/grid/ResourceDiscovery.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/plugin/grid/ResourceDiscovery.java	(revision 1396)
@@ -6,4 +6,5 @@
 import schedframe.scheduling.SchedulerDescription;
 import schedframe.scheduling.SecurityContext;
+import schedframe.scheduling.plugin.Module;
 import schedframe.scheduling.tasks.requirements.AbstractResourceRequirements;
 
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/global/GridBroker.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/global/GridBroker.java	(revision 1385)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/global/GridBroker.java	(revision 1396)
@@ -12,7 +12,7 @@
 import schedframe.scheduling.Scheduler;
 import schedframe.scheduling.manager.resources.ManagedResources;
+import schedframe.scheduling.plugin.ModuleListImpl;
 import schedframe.scheduling.plugin.SchedulingPlugin;
 import schedframe.scheduling.plugin.estimation.ExecutionTimeEstimationPlugin;
-import schedframe.scheduling.plugin.grid.ModuleListImpl;
 import schedframe.scheduling.queue.TaskQueueList;
 
